(defvar *files-to-compile-and-load* '())
(defvar *dump-icfp-core* t)

(defmacro add-file (file)
  `(setf *files-to-compile-and-load*
    (remove-duplicates
     (nconc *files-to-compile-and-load* (list ,(string-downcase file)))
     :test #'string-equal)))

(defun recompile ()
  (dolist (file *files-to-compile-and-load*)
    (compile-file file)
    (load file
          :if-source-newer :compile
          :verbose t))
  (when *dump-icfp-core*
    (dump-self)))

(defun dump-self ()
  (setf *gc-verbose* nil)
  (setf *load-verbose* nil)
  (save-lisp "icfp.core"
             :purify t
             :init-function (lambda ()
                              (main)
                              ;; return value
                              0)
             :load-init-file nil
             :site-init nil
             :print-herald nil
             :process-command-line nil
             :batch-mode t)
  (quit))